---
title: llarp/apple/vpn_platform.hpp

---

# llarp/apple/vpn_platform.hpp



## Namespaces

| Name           |
| -------------- |
| **[llarp](Namespaces/namespacellarp.md)** <br>[crypto.hpp] |
| **[llarp::apple](Namespaces/namespacellarp_1_1apple.md)**  |

## Classes

|                | Name           |
| -------------- | -------------- |
| class | **[llarp::apple::VPNPlatform](Classes/classllarp_1_1apple_1_1VPNPlatform.md)**  |




## Source code

```cpp
#pragma once

#include <llarp/vpn/platform.hpp>
#include "llarp/net/ip_packet.hpp"
#include "route_manager.hpp"

namespace llarp::apple
{
  using packet_write_callback = std::function<bool(int af_family, void* data, int size)>;

  class VPNPlatform final : public vpn::Platform
  {
   public:
    explicit VPNPlatform(
        Context& ctx,
        packet_write_callback packet_writer,
        llarp_route_callbacks route_callbacks,
        void* callback_context);

    std::shared_ptr<vpn::NetworkInterface>
    ObtainInterface(vpn::InterfaceInfo, AbstractRouter*) override;

    vpn::IRouteManager&
    RouteManager() override
    {
      return m_RouteManager;
    }

   private:
    Context& m_Context;
    apple::RouteManager m_RouteManager;
    packet_write_callback m_PacketWriter;
  };

}  // namespace llarp::apple
```


-------------------------------

Updated on 2023-03-14 at 18:04:25 +0000
